property snapDistance, snapTarget, xoffset, yoffset, tracking, boxtop, boxleft, boxright, boxbottom

on beginSprite me
  set boxtop to the locV of sprite snapTarget - snapDistance
  set boxbottom to the locV of sprite snapTarget + snapDistance
  set boxleft to the locH of sprite snapTarget - snapDistance
  set boxright to the locH of sprite snapTarget + snapDistance
end

on prepareFrame me
  if tracking then
    if inbox(me, the mouseH - xoffset, the mouseV - yoffset) then
      snap(me)
    else
      set the locH of sprite the spriteNum of me to the mouseH - xoffset
      set the locV of sprite the spriteNum of me to the mouseV - yoffset
    end if
  end if
end

on mouseDown me
  set tracking to 1
  set xoffset to the mouseH - the locH of sprite the spriteNum of me
  set yoffset to the mouseV - the locV of sprite the spriteNum of me
end

on mouseUp me
  set tracking to 0
end

on snap me
  set the locH of sprite the spriteNum of me to the locH of sprite snapTarget
  set the locV of sprite the spriteNum of me to the locV of sprite snapTarget
end

on inbox me, X, Y
  if (X < boxright) and (X > boxleft) and (Y < boxbottom) and (Y > boxtop) then
    return 1
  end if
  return 0
end

on getPropertyDescriptionList
  set p_list to [#snapDistance: [#comment: "Snap Distance:", #format: #integer, #default: 8], #snapTarget: [#comment: "Target Sprite:", #format: #integer, #default: 1]]
  return p_list
end

on getBehaviorDescription
  return "Cause a sprite to snap to the registration point of the target sprite while being dragged.  " & RETURN & "PARAMETERS:" & RETURN & "• Snap Distance - Enter the range in pixels within which snapping occurs." & RETURN & "• Snap Target - Enter the channel number of the sprite to snap to."
end
