property WhichFrame, whichevent, playMode

on initGotoFrame me
  init(me)
end

on mouseUp me
  if whichevent = #mouseUp then
    init(me)
  end if
end

on prepareFrame me
  if whichevent = #prepareFrame then
    init(me)
  end if
end

on exitFrame me
  if whichevent = #exitFrame then
    init(me)
  end if
end

on init me
  if the playMode of me = "Play and Return" then
    play frame the WhichFrame of me
  else
    go(the WhichFrame of me)
  end if
end

on getPropertyDescriptionList
  set p_list to [#WhichFrame: [#comment: "Destination Frame:", #format: #integer, #default: 1], #whichevent: [#comment: "Initializing Event:", #format: #symbol, #range: [#mouseUp, #prepareFrame, #exitFrame, #initGotoFrame], #default: #mouseUp], #playMode: [#comment: "Play Mode:", #format: #symbol, #range: ["Go to", "Play and Return"], #default: "Go to"]]
  return p_list
end

on getBehaviorDescription
  return "Moves the Playback Head to the designated frame when the specified event occurs.  Drag to a sprite or frame in the script channel." && RETURN & "PARAMETERS:" && RETURN & "• Destination Frame - Enter the number of the desired frame." && RETURN & "• Initializing Event - Choose the event that triggers the behavior." && RETURN & "• Play Mode - Choose Play and Return to make the Playback Head return to the current location when the Play Done behavior is encountered. Choose Go To to make the Playback Head continue from the specified frame until explicitly sent to a new location."
end
